/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectResolvingEList;

import safe10.classmodel.requirements.softwaresafetyrequirements.ErrorHandlerSSR;

import safe10.classmodel.requirements.softwaresafetyrequirements.comparison.Comparison;
import safe10.classmodel.requirements.softwaresafetyrequirements.comparison.ComparisonOperation;
import safe10.classmodel.requirements.softwaresafetyrequirements.comparison.ComparisonPackage;
import safe10.classmodel.requirements.softwaresafetyrequirements.comparison.ComparisonParameter;

import safe10.classmodel.requirements.softwaresafetyrequirements.impl.ErrorDetectionSSRImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Comparison</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl.ComparisonImpl#getTolerance <em>Tolerance</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl.ComparisonImpl#getOperation <em>Operation</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl.ComparisonImpl#getComparisonFalse <em>Comparison False</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl.ComparisonImpl#getComparisonTrue <em>Comparison True</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl.ComparisonImpl#getParamB <em>Param B</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.comparison.impl.ComparisonImpl#getParamA <em>Param A</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class ComparisonImpl extends ErrorDetectionSSRImpl implements Comparison
{
  /**
   * The default value of the '{@link #getTolerance() <em>Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTolerance()
   * @generated
   * @ordered
   */
  protected static final Double TOLERANCE_EDEFAULT = new Double(0.0);

  /**
   * The cached value of the '{@link #getTolerance() <em>Tolerance</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTolerance()
   * @generated
   * @ordered
   */
  protected Double tolerance = TOLERANCE_EDEFAULT;

  /**
   * This is true if the Tolerance attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean toleranceESet;

  /**
   * The default value of the '{@link #getOperation() <em>Operation</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperation()
   * @generated
   * @ordered
   */
  protected static final ComparisonOperation OPERATION_EDEFAULT = ComparisonOperation.LT;

  /**
   * The cached value of the '{@link #getOperation() <em>Operation</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getOperation()
   * @generated
   * @ordered
   */
  protected ComparisonOperation operation = OPERATION_EDEFAULT;

  /**
   * This is true if the Operation attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean operationESet;

  /**
   * The cached value of the '{@link #getComparisonFalse() <em>Comparison False</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComparisonFalse()
   * @generated
   * @ordered
   */
  protected EList<ErrorHandlerSSR> comparisonFalse;

  /**
   * The cached value of the '{@link #getComparisonTrue() <em>Comparison True</em>}' reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getComparisonTrue()
   * @generated
   * @ordered
   */
  protected EList<ErrorHandlerSSR> comparisonTrue;

  /**
   * The cached value of the '{@link #getParamB() <em>Param B</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParamB()
   * @generated
   * @ordered
   */
  protected ComparisonParameter paramB;

  /**
   * The cached value of the '{@link #getParamA() <em>Param A</em>}' reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getParamA()
   * @generated
   * @ordered
   */
  protected ComparisonParameter paramA;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected ComparisonImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return ComparisonPackage.Literals.COMPARISON;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Double getTolerance()
  {
    return tolerance;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTolerance(Double newTolerance)
  {
    Double oldTolerance = tolerance;
    tolerance = newTolerance;
    boolean oldToleranceESet = toleranceESet;
    toleranceESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ComparisonPackage.COMPARISON__TOLERANCE, oldTolerance, tolerance, !oldToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetTolerance()
  {
    Double oldTolerance = tolerance;
    boolean oldToleranceESet = toleranceESet;
    tolerance = TOLERANCE_EDEFAULT;
    toleranceESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, ComparisonPackage.COMPARISON__TOLERANCE, oldTolerance, TOLERANCE_EDEFAULT, oldToleranceESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetTolerance()
  {
    return toleranceESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonOperation getOperation()
  {
    return operation;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setOperation(ComparisonOperation newOperation)
  {
    ComparisonOperation oldOperation = operation;
    operation = newOperation == null ? OPERATION_EDEFAULT : newOperation;
    boolean oldOperationESet = operationESet;
    operationESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ComparisonPackage.COMPARISON__OPERATION, oldOperation, operation, !oldOperationESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetOperation()
  {
    ComparisonOperation oldOperation = operation;
    boolean oldOperationESet = operationESet;
    operation = OPERATION_EDEFAULT;
    operationESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, ComparisonPackage.COMPARISON__OPERATION, oldOperation, OPERATION_EDEFAULT, oldOperationESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetOperation()
  {
    return operationESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorHandlerSSR> getComparisonFalse()
  {
    if (comparisonFalse == null)
    {
      comparisonFalse = new EObjectResolvingEList<ErrorHandlerSSR>(ErrorHandlerSSR.class, this, ComparisonPackage.COMPARISON__COMPARISON_FALSE);
    }
    return comparisonFalse;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<ErrorHandlerSSR> getComparisonTrue()
  {
    if (comparisonTrue == null)
    {
      comparisonTrue = new EObjectResolvingEList<ErrorHandlerSSR>(ErrorHandlerSSR.class, this, ComparisonPackage.COMPARISON__COMPARISON_TRUE);
    }
    return comparisonTrue;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter getParamB()
  {
    if (paramB != null && paramB.eIsProxy())
    {
      InternalEObject oldParamB = (InternalEObject)paramB;
      paramB = (ComparisonParameter)eResolveProxy(oldParamB);
      if (paramB != oldParamB)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ComparisonPackage.COMPARISON__PARAM_B, oldParamB, paramB));
      }
    }
    return paramB;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter basicGetParamB()
  {
    return paramB;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParamB(ComparisonParameter newParamB)
  {
    ComparisonParameter oldParamB = paramB;
    paramB = newParamB;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ComparisonPackage.COMPARISON__PARAM_B, oldParamB, paramB));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter getParamA()
  {
    if (paramA != null && paramA.eIsProxy())
    {
      InternalEObject oldParamA = (InternalEObject)paramA;
      paramA = (ComparisonParameter)eResolveProxy(oldParamA);
      if (paramA != oldParamA)
      {
        if (eNotificationRequired())
          eNotify(new ENotificationImpl(this, Notification.RESOLVE, ComparisonPackage.COMPARISON__PARAM_A, oldParamA, paramA));
      }
    }
    return paramA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ComparisonParameter basicGetParamA()
  {
    return paramA;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setParamA(ComparisonParameter newParamA)
  {
    ComparisonParameter oldParamA = paramA;
    paramA = newParamA;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, ComparisonPackage.COMPARISON__PARAM_A, oldParamA, paramA));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case ComparisonPackage.COMPARISON__TOLERANCE:
        return getTolerance();
      case ComparisonPackage.COMPARISON__OPERATION:
        return getOperation();
      case ComparisonPackage.COMPARISON__COMPARISON_FALSE:
        return getComparisonFalse();
      case ComparisonPackage.COMPARISON__COMPARISON_TRUE:
        return getComparisonTrue();
      case ComparisonPackage.COMPARISON__PARAM_B:
        if (resolve) return getParamB();
        return basicGetParamB();
      case ComparisonPackage.COMPARISON__PARAM_A:
        if (resolve) return getParamA();
        return basicGetParamA();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case ComparisonPackage.COMPARISON__TOLERANCE:
   			setTolerance((Double)newValue);
        return;
      case ComparisonPackage.COMPARISON__OPERATION:
   			setOperation((ComparisonOperation)newValue);
        return;
      case ComparisonPackage.COMPARISON__COMPARISON_FALSE:
        getComparisonFalse().clear();
        getComparisonFalse().addAll((Collection<? extends ErrorHandlerSSR>)newValue);
        return;
      case ComparisonPackage.COMPARISON__COMPARISON_TRUE:
        getComparisonTrue().clear();
        getComparisonTrue().addAll((Collection<? extends ErrorHandlerSSR>)newValue);
        return;
      case ComparisonPackage.COMPARISON__PARAM_B:
   			setParamB((ComparisonParameter)newValue);
        return;
      case ComparisonPackage.COMPARISON__PARAM_A:
   			setParamA((ComparisonParameter)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case ComparisonPackage.COMPARISON__TOLERANCE:
        unsetTolerance();
        return;
      case ComparisonPackage.COMPARISON__OPERATION:
        unsetOperation();
        return;
      case ComparisonPackage.COMPARISON__COMPARISON_FALSE:
        getComparisonFalse().clear();
        return;
      case ComparisonPackage.COMPARISON__COMPARISON_TRUE:
        getComparisonTrue().clear();
        return;
      case ComparisonPackage.COMPARISON__PARAM_B:
        	setParamB((ComparisonParameter)null);
        return;
      case ComparisonPackage.COMPARISON__PARAM_A:
        	setParamA((ComparisonParameter)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case ComparisonPackage.COMPARISON__TOLERANCE:
        return isSetTolerance();
      case ComparisonPackage.COMPARISON__OPERATION:
        return isSetOperation();
      case ComparisonPackage.COMPARISON__COMPARISON_FALSE:
        return comparisonFalse != null && !comparisonFalse.isEmpty();
      case ComparisonPackage.COMPARISON__COMPARISON_TRUE:
        return comparisonTrue != null && !comparisonTrue.isEmpty();
      case ComparisonPackage.COMPARISON__PARAM_B:
        return paramB != null;
      case ComparisonPackage.COMPARISON__PARAM_A:
        return paramA != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (tolerance: ");
    if (toleranceESet) result.append(tolerance); else result.append("<unset>");
    result.append(", operation: ");
    if (operationESet) result.append(operation); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //ComparisonImpl
