/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.common.util.EList;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;

import org.eclipse.sphinx.emf.ecore.ExtendedEObjectImpl;

import safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.MemoryRange;
import safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.MemorySelfTestConfig;
import safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.MemoryTestAlgorithms;
import safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.MemoryselftestPackage;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Memory Self Test Config</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.impl.MemorySelfTestConfigImpl#getPeriodMs <em>Period Ms</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.impl.MemorySelfTestConfigImpl#getExecuteInChunks <em>Execute In Chunks</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.impl.MemorySelfTestConfigImpl#getNumberOfChunks <em>Number Of Chunks</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.impl.MemorySelfTestConfigImpl#getTestAlgorithm <em>Test Algorithm</em>}</li>
 *   <li>{@link safe10.classmodel.requirements.softwaresafetyrequirements.memoryselftest.impl.MemorySelfTestConfigImpl#getMemoryRange <em>Memory Range</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class MemorySelfTestConfigImpl extends ExtendedEObjectImpl implements MemorySelfTestConfig
{
  /**
   * The default value of the '{@link #getPeriodMs() <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPeriodMs()
   * @generated
   * @ordered
   */
  protected static final String PERIOD_MS_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getPeriodMs() <em>Period Ms</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getPeriodMs()
   * @generated
   * @ordered
   */
  protected String periodMs = PERIOD_MS_EDEFAULT;

  /**
   * This is true if the Period Ms attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean periodMsESet;

  /**
   * The default value of the '{@link #getExecuteInChunks() <em>Execute In Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecuteInChunks()
   * @generated
   * @ordered
   */
  protected static final Boolean EXECUTE_IN_CHUNKS_EDEFAULT = Boolean.FALSE;

  /**
   * The cached value of the '{@link #getExecuteInChunks() <em>Execute In Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getExecuteInChunks()
   * @generated
   * @ordered
   */
  protected Boolean executeInChunks = EXECUTE_IN_CHUNKS_EDEFAULT;

  /**
   * This is true if the Execute In Chunks attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean executeInChunksESet;

  /**
   * The default value of the '{@link #getNumberOfChunks() <em>Number Of Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNumberOfChunks()
   * @generated
   * @ordered
   */
  protected static final Integer NUMBER_OF_CHUNKS_EDEFAULT = new Integer(0);

  /**
   * The cached value of the '{@link #getNumberOfChunks() <em>Number Of Chunks</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getNumberOfChunks()
   * @generated
   * @ordered
   */
  protected Integer numberOfChunks = NUMBER_OF_CHUNKS_EDEFAULT;

  /**
   * This is true if the Number Of Chunks attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean numberOfChunksESet;

  /**
   * The default value of the '{@link #getTestAlgorithm() <em>Test Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTestAlgorithm()
   * @generated
   * @ordered
   */
  protected static final MemoryTestAlgorithms TEST_ALGORITHM_EDEFAULT = MemoryTestAlgorithms.GALPAT;

  /**
   * The cached value of the '{@link #getTestAlgorithm() <em>Test Algorithm</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getTestAlgorithm()
   * @generated
   * @ordered
   */
  protected MemoryTestAlgorithms testAlgorithm = TEST_ALGORITHM_EDEFAULT;

  /**
   * This is true if the Test Algorithm attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean testAlgorithmESet;

  /**
   * The cached value of the '{@link #getMemoryRange() <em>Memory Range</em>}' containment reference list.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getMemoryRange()
   * @generated
   * @ordered
   */
  protected EList<MemoryRange> memoryRange;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected MemorySelfTestConfigImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return MemoryselftestPackage.Literals.MEMORY_SELF_TEST_CONFIG;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getPeriodMs()
  {
    return periodMs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setPeriodMs(String newPeriodMs)
  {
    String oldPeriodMs = periodMs;
    periodMs = newPeriodMs;
    boolean oldPeriodMsESet = periodMsESet;
    periodMsESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__PERIOD_MS, oldPeriodMs, periodMs, !oldPeriodMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetPeriodMs()
  {
    String oldPeriodMs = periodMs;
    boolean oldPeriodMsESet = periodMsESet;
    periodMs = PERIOD_MS_EDEFAULT;
    periodMsESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__PERIOD_MS, oldPeriodMs, PERIOD_MS_EDEFAULT, oldPeriodMsESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetPeriodMs()
  {
    return periodMsESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Boolean getExecuteInChunks()
  {
    return executeInChunks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setExecuteInChunks(Boolean newExecuteInChunks)
  {
    Boolean oldExecuteInChunks = executeInChunks;
    executeInChunks = newExecuteInChunks;
    boolean oldExecuteInChunksESet = executeInChunksESet;
    executeInChunksESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__EXECUTE_IN_CHUNKS, oldExecuteInChunks, executeInChunks, !oldExecuteInChunksESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetExecuteInChunks()
  {
    Boolean oldExecuteInChunks = executeInChunks;
    boolean oldExecuteInChunksESet = executeInChunksESet;
    executeInChunks = EXECUTE_IN_CHUNKS_EDEFAULT;
    executeInChunksESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__EXECUTE_IN_CHUNKS, oldExecuteInChunks, EXECUTE_IN_CHUNKS_EDEFAULT, oldExecuteInChunksESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetExecuteInChunks()
  {
    return executeInChunksESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public Integer getNumberOfChunks()
  {
    return numberOfChunks;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setNumberOfChunks(Integer newNumberOfChunks)
  {
    Integer oldNumberOfChunks = numberOfChunks;
    numberOfChunks = newNumberOfChunks;
    boolean oldNumberOfChunksESet = numberOfChunksESet;
    numberOfChunksESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__NUMBER_OF_CHUNKS, oldNumberOfChunks, numberOfChunks, !oldNumberOfChunksESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetNumberOfChunks()
  {
    Integer oldNumberOfChunks = numberOfChunks;
    boolean oldNumberOfChunksESet = numberOfChunksESet;
    numberOfChunks = NUMBER_OF_CHUNKS_EDEFAULT;
    numberOfChunksESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__NUMBER_OF_CHUNKS, oldNumberOfChunks, NUMBER_OF_CHUNKS_EDEFAULT, oldNumberOfChunksESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetNumberOfChunks()
  {
    return numberOfChunksESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public MemoryTestAlgorithms getTestAlgorithm()
  {
    return testAlgorithm;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setTestAlgorithm(MemoryTestAlgorithms newTestAlgorithm)
  {
    MemoryTestAlgorithms oldTestAlgorithm = testAlgorithm;
    testAlgorithm = newTestAlgorithm == null ? TEST_ALGORITHM_EDEFAULT : newTestAlgorithm;
    boolean oldTestAlgorithmESet = testAlgorithmESet;
    testAlgorithmESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__TEST_ALGORITHM, oldTestAlgorithm, testAlgorithm, !oldTestAlgorithmESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetTestAlgorithm()
  {
    MemoryTestAlgorithms oldTestAlgorithm = testAlgorithm;
    boolean oldTestAlgorithmESet = testAlgorithmESet;
    testAlgorithm = TEST_ALGORITHM_EDEFAULT;
    testAlgorithmESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__TEST_ALGORITHM, oldTestAlgorithm, TEST_ALGORITHM_EDEFAULT, oldTestAlgorithmESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetTestAlgorithm()
  {
    return testAlgorithmESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public EList<MemoryRange> getMemoryRange()
  {
    if (memoryRange == null)
    {
      memoryRange = new EObjectContainmentEList<MemoryRange>(MemoryRange.class, this, MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__MEMORY_RANGE);
    }
    return memoryRange;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__MEMORY_RANGE:
        return ((InternalEList<?>)getMemoryRange()).basicRemove(otherEnd, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__PERIOD_MS:
        return getPeriodMs();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__EXECUTE_IN_CHUNKS:
        return getExecuteInChunks();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__NUMBER_OF_CHUNKS:
        return getNumberOfChunks();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__TEST_ALGORITHM:
        return getTestAlgorithm();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__MEMORY_RANGE:
        return getMemoryRange();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @SuppressWarnings("unchecked")
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__PERIOD_MS:
   			setPeriodMs((String)newValue);
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__EXECUTE_IN_CHUNKS:
   			setExecuteInChunks((Boolean)newValue);
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__NUMBER_OF_CHUNKS:
   			setNumberOfChunks((Integer)newValue);
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__TEST_ALGORITHM:
   			setTestAlgorithm((MemoryTestAlgorithms)newValue);
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__MEMORY_RANGE:
        getMemoryRange().clear();
        getMemoryRange().addAll((Collection<? extends MemoryRange>)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__PERIOD_MS:
        unsetPeriodMs();
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__EXECUTE_IN_CHUNKS:
        unsetExecuteInChunks();
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__NUMBER_OF_CHUNKS:
        unsetNumberOfChunks();
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__TEST_ALGORITHM:
        unsetTestAlgorithm();
        return;
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__MEMORY_RANGE:
        getMemoryRange().clear();
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__PERIOD_MS:
        return isSetPeriodMs();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__EXECUTE_IN_CHUNKS:
        return isSetExecuteInChunks();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__NUMBER_OF_CHUNKS:
        return isSetNumberOfChunks();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__TEST_ALGORITHM:
        return isSetTestAlgorithm();
      case MemoryselftestPackage.MEMORY_SELF_TEST_CONFIG__MEMORY_RANGE:
        return memoryRange != null && !memoryRange.isEmpty();
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (periodMs: ");
    if (periodMsESet) result.append(periodMs); else result.append("<unset>");
    result.append(", executeInChunks: ");
    if (executeInChunksESet) result.append(executeInChunks); else result.append("<unset>");
    result.append(", numberOfChunks: ");
    if (numberOfChunksESet) result.append(numberOfChunks); else result.append("<unset>");
    result.append(", testAlgorithm: ");
    if (testAlgorithmESet) result.append(testAlgorithm); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //MemorySelfTestConfigImpl
