/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package safe10.classmodel.commonstructure.safetyextensions.impl;

import eastadl21.east_adl.structure.functionmodeling.AnalysisFunctionType;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.InternalEObject;

import org.eclipse.emf.ecore.impl.ENotificationImpl;

import safe10.classmodel.commonstructure.safetyextensions.FunctionalSafetyExtension;
import safe10.classmodel.commonstructure.safetyextensions.SafetyExtension;
import safe10.classmodel.commonstructure.safetyextensions.SafetyextensionsPackage;

import safe10.classmodel.commonstructure.toplevel.Identifiable;
import safe10.classmodel.commonstructure.toplevel.PackageableElement;
import safe10.classmodel.commonstructure.toplevel.Referrable;
import safe10.classmodel.commonstructure.toplevel.SAFEElement;
import safe10.classmodel.commonstructure.toplevel.ToplevelPackage;

import safe10.classmodel.errormodel.ErrorModel;

import safe10.classmodel.requirements.impl.AllocationTargetImpl;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Functional Safety Extension</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link safe10.classmodel.commonstructure.safetyextensions.impl.FunctionalSafetyExtensionImpl#getShortName <em>Short Name</em>}</li>
 *   <li>{@link safe10.classmodel.commonstructure.safetyextensions.impl.FunctionalSafetyExtensionImpl#getCategory <em>Category</em>}</li>
 *   <li>{@link safe10.classmodel.commonstructure.safetyextensions.impl.FunctionalSafetyExtensionImpl#getUuid <em>Uuid</em>}</li>
 *   <li>{@link safe10.classmodel.commonstructure.safetyextensions.impl.FunctionalSafetyExtensionImpl#getName <em>Name</em>}</li>
 *   <li>{@link safe10.classmodel.commonstructure.safetyextensions.impl.FunctionalSafetyExtensionImpl#getErrorModel <em>Error Model</em>}</li>
 *   <li>{@link safe10.classmodel.commonstructure.safetyextensions.impl.FunctionalSafetyExtensionImpl#getScope <em>Scope</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class FunctionalSafetyExtensionImpl extends AllocationTargetImpl implements FunctionalSafetyExtension
{
  /**
   * The default value of the '{@link #getShortName() <em>Short Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getShortName()
   * @generated
   * @ordered
   */
  protected static final String SHORT_NAME_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getShortName() <em>Short Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getShortName()
   * @generated
   * @ordered
   */
  protected String shortName = SHORT_NAME_EDEFAULT;

  /**
   * This is true if the Short Name attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean shortNameESet;

  /**
   * The default value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected static final String CATEGORY_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getCategory() <em>Category</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getCategory()
   * @generated
   * @ordered
   */
  protected String category = CATEGORY_EDEFAULT;

  /**
   * This is true if the Category attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean categoryESet;

  /**
   * The default value of the '{@link #getUuid() <em>Uuid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUuid()
   * @generated
   * @ordered
   */
  protected static final String UUID_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getUuid() <em>Uuid</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getUuid()
   * @generated
   * @ordered
   */
  protected String uuid = UUID_EDEFAULT;

  /**
   * This is true if the Uuid attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean uuidESet;

  /**
   * The default value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected static final String NAME_EDEFAULT = "";

  /**
   * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getName()
   * @generated
   * @ordered
   */
  protected String name = NAME_EDEFAULT;

  /**
   * This is true if the Name attribute has been set.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   * @ordered
   */
  protected boolean nameESet;

  /**
   * The cached value of the '{@link #getErrorModel() <em>Error Model</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getErrorModel()
   * @generated
   * @ordered
   */
  protected ErrorModel errorModel;

  /**
   * The cached value of the '{@link #getScope() <em>Scope</em>}' containment reference.
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @see #getScope()
   * @generated
   * @ordered
   */
  protected AnalysisFunctionType scope;

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  protected FunctionalSafetyExtensionImpl()
  {
    super();
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  protected EClass eStaticClass()
  {
    return SafetyextensionsPackage.Literals.FUNCTIONAL_SAFETY_EXTENSION;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getShortName()
  {
    return shortName;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setShortName(String newShortName)
  {
    String oldShortName = shortName;
    shortName = newShortName;
    boolean oldShortNameESet = shortNameESet;
    shortNameESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME, oldShortName, shortName, !oldShortNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetShortName()
  {
    String oldShortName = shortName;
    boolean oldShortNameESet = shortNameESet;
    shortName = SHORT_NAME_EDEFAULT;
    shortNameESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME, oldShortName, SHORT_NAME_EDEFAULT, oldShortNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetShortName()
  {
    return shortNameESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getCategory()
  {
    return category;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setCategory(String newCategory)
  {
    String oldCategory = category;
    category = newCategory;
    boolean oldCategoryESet = categoryESet;
    categoryESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY, oldCategory, category, !oldCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetCategory()
  {
    String oldCategory = category;
    boolean oldCategoryESet = categoryESet;
    category = CATEGORY_EDEFAULT;
    categoryESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY, oldCategory, CATEGORY_EDEFAULT, oldCategoryESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetCategory()
  {
    return categoryESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getUuid()
  {
    return uuid;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setUuid(String newUuid)
  {
    String oldUuid = uuid;
    uuid = newUuid;
    boolean oldUuidESet = uuidESet;
    uuidESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID, oldUuid, uuid, !oldUuidESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetUuid()
  {
    String oldUuid = uuid;
    boolean oldUuidESet = uuidESet;
    uuid = UUID_EDEFAULT;
    uuidESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID, oldUuid, UUID_EDEFAULT, oldUuidESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetUuid()
  {
    return uuidESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public String getName()
  {
    return name;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setName(String newName)
  {
    String oldName = name;
    name = newName;
    boolean oldNameESet = nameESet;
    nameESet = true;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME, oldName, name, !oldNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void unsetName()
  {
    String oldName = name;
    boolean oldNameESet = nameESet;
    name = NAME_EDEFAULT;
    nameESet = false;
    if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.UNSET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME, oldName, NAME_EDEFAULT, oldNameESet));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public boolean isSetName()
  {
    return nameESet;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public ErrorModel getErrorModel()
  {
    return errorModel;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetErrorModel(ErrorModel newErrorModel, NotificationChain msgs)
  {
    ErrorModel oldErrorModel = errorModel;
    errorModel = newErrorModel;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL, oldErrorModel, newErrorModel);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setErrorModel(ErrorModel newErrorModel)
  {
    if (newErrorModel != errorModel)
    {
      NotificationChain msgs = null;
      if (errorModel != null)
        msgs = ((InternalEObject)errorModel).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL, null, msgs);
      if (newErrorModel != null)
        msgs = ((InternalEObject)newErrorModel).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL, null, msgs);
      msgs = basicSetErrorModel(newErrorModel, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL, newErrorModel, newErrorModel));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public AnalysisFunctionType getScope()
  {
    return scope;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public NotificationChain basicSetScope(AnalysisFunctionType newScope, NotificationChain msgs)
  {
    AnalysisFunctionType oldScope = scope;
    scope = newScope;
    if (eNotificationRequired())
    {
      ENotificationImpl notification = new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE, oldScope, newScope);
      if (msgs == null) msgs = notification; else msgs.add(notification);
    }
    return msgs;
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  public void setScope(AnalysisFunctionType newScope)
  {
    if (newScope != scope)
    {
      NotificationChain msgs = null;
      if (scope != null)
        msgs = ((InternalEObject)scope).eInverseRemove(this, EOPPOSITE_FEATURE_BASE - SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE, null, msgs);
      if (newScope != null)
        msgs = ((InternalEObject)newScope).eInverseAdd(this, EOPPOSITE_FEATURE_BASE - SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE, null, msgs);
      msgs = basicSetScope(newScope, msgs);
      if (msgs != null) msgs.dispatch();
    }
    else if (eNotificationRequired())
      eNotify(new ENotificationImpl(this, Notification.SET, SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE, newScope, newScope));
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, NotificationChain msgs)
  {
    switch (featureID)
    {
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL:
        return basicSetErrorModel(null, msgs);
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE:
        return basicSetScope(null, msgs);
    }
    return super.eInverseRemove(otherEnd, featureID, msgs);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public Object eGet(int featureID, boolean resolve, boolean coreType)
  {
    switch (featureID)
    {
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME:
        return getShortName();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY:
        return getCategory();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID:
        return getUuid();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME:
        return getName();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL:
        return getErrorModel();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE:
        return getScope();
    }
    return super.eGet(featureID, resolve, coreType);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eSet(int featureID, Object newValue)
  {
    switch (featureID)
    {
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME:
   			setShortName((String)newValue);
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY:
   			setCategory((String)newValue);
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID:
   			setUuid((String)newValue);
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME:
   			setName((String)newValue);
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL:
   			setErrorModel((ErrorModel)newValue);
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE:
   			setScope((AnalysisFunctionType)newValue);
        return;
    }
    super.eSet(featureID, newValue);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public void eUnset(int featureID)
  {
    switch (featureID)
    {
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME:
        unsetShortName();
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY:
        unsetCategory();
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID:
        unsetUuid();
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME:
        unsetName();
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL:
        	setErrorModel((ErrorModel)null);
        return;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE:
        	setScope((AnalysisFunctionType)null);
        return;
    }
    super.eUnset(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public boolean eIsSet(int featureID)
  {
    switch (featureID)
    {
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME:
        return isSetShortName();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY:
        return isSetCategory();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID:
        return isSetUuid();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME:
        return isSetName();
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL:
        return errorModel != null;
      case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SCOPE:
        return scope != null;
    }
    return super.eIsSet(featureID);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eBaseStructuralFeatureID(int derivedFeatureID, Class<?> baseClass)
  {
    if (baseClass == Referrable.class)
    {
      switch (derivedFeatureID)
      {
        case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME: return ToplevelPackage.REFERRABLE__SHORT_NAME;
        default: return -1;
      }
    }
    if (baseClass == Identifiable.class)
    {
      switch (derivedFeatureID)
      {
        case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY: return ToplevelPackage.IDENTIFIABLE__CATEGORY;
        case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID: return ToplevelPackage.IDENTIFIABLE__UUID;
        default: return -1;
      }
    }
    if (baseClass == PackageableElement.class)
    {
      switch (derivedFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == SAFEElement.class)
    {
      switch (derivedFeatureID)
      {
        case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME: return ToplevelPackage.SAFE_ELEMENT__NAME;
        default: return -1;
      }
    }
    if (baseClass == SafetyExtension.class)
    {
      switch (derivedFeatureID)
      {
        case SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL: return SafetyextensionsPackage.SAFETY_EXTENSION__ERROR_MODEL;
        default: return -1;
      }
    }
    return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public int eDerivedStructuralFeatureID(int baseFeatureID, Class<?> baseClass)
  {
    if (baseClass == Referrable.class)
    {
      switch (baseFeatureID)
      {
        case ToplevelPackage.REFERRABLE__SHORT_NAME: return SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__SHORT_NAME;
        default: return -1;
      }
    }
    if (baseClass == Identifiable.class)
    {
      switch (baseFeatureID)
      {
        case ToplevelPackage.IDENTIFIABLE__CATEGORY: return SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__CATEGORY;
        case ToplevelPackage.IDENTIFIABLE__UUID: return SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__UUID;
        default: return -1;
      }
    }
    if (baseClass == PackageableElement.class)
    {
      switch (baseFeatureID)
      {
        default: return -1;
      }
    }
    if (baseClass == SAFEElement.class)
    {
      switch (baseFeatureID)
      {
        case ToplevelPackage.SAFE_ELEMENT__NAME: return SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__NAME;
        default: return -1;
      }
    }
    if (baseClass == SafetyExtension.class)
    {
      switch (baseFeatureID)
      {
        case SafetyextensionsPackage.SAFETY_EXTENSION__ERROR_MODEL: return SafetyextensionsPackage.FUNCTIONAL_SAFETY_EXTENSION__ERROR_MODEL;
        default: return -1;
      }
    }
    return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
  }

  /**
   * <!-- begin-user-doc -->
   * <!-- end-user-doc -->
   * @generated
   */
  @Override
  public String toString()
  {
    if (eIsProxy()) return super.toString();

    StringBuffer result = new StringBuffer(super.toString());
    result.append(" (shortName: ");
    if (shortNameESet) result.append(shortName); else result.append("<unset>");
    result.append(", category: ");
    if (categoryESet) result.append(category); else result.append("<unset>");
    result.append(", uuid: ");
    if (uuidESet) result.append(uuid); else result.append("<unset>");
    result.append(", name: ");
    if (nameESet) result.append(name); else result.append("<unset>");
    result.append(')');
    return result.toString();
  }

} //FunctionalSafetyExtensionImpl
